This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours

Bug 679907

Summary: please add atomic request to plymouth protocol for asking for cached passwords and input passwords
Product: [Fedora] Fedora Reporter: Lennart Poettering <lpoetter>
Component: plymouthAssignee: Ray Strode [halfline] <rstrode>
Status: CLOSED WONTFIX QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: unspecified Docs Contact:
Priority: unspecified    
Version: 15CC: awalls, bill-bugzilla.redhat.com, bruno, fedora, frankly3d, frigoris.ma, jonas.th, mishu, rstrode, twaugh
Target Milestone: ---   
Target Release: ---   
Hardware: Unspecified   
OS: Unspecified   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2012-08-07 14:16:03 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Bug Depends On:    
Bug Blocks: 677438, 749027    

Description Lennart Poettering 2011-02-23 15:15:51 EST
Currently, if multiple clients want to query passwords via plymouth at the same time, and want to make use of cached passwords they will first ask for the cached passwords. Then get an empty response. Then rerequest the password from user input. Hence: even though passwords are cached the user will be asked twice.

Here's the request I'd like to see:

A) Client sends to Plymouth the passwords it already knows
B) If Plymouth' cache contains new passwords that do not appear the client's list it sends those back.
C) If Plymouth' cache contains no new passwords it asks the user for one and sends it back.

It is important that the Plymouth does not process any other password requests while B or C are active. Most importantly: it should NOT process requests from other clients if it is currently asking a question to the user. This password entered by the user must already be considered when returning a reply to the caller.

The packet payload in both directions would be really simply, just a list of NUL terminated strings.
Comment 1 Lennart Poettering 2011-02-24 10:38:38 EST
Hmm, here's a simpler idea:

every time plymouth acquires a password it should increase a generation counter. Then, when a client wants to know cached passwords it just passes its last seen generation counter to Plymouth (0 initially). Plymouth then sends all passwords with a newer generation counter back. If there aren't any it asks the user for a new password, and assigns it the next free generation counter id. And in its response it always sends back to the client the newest generation counter it has.

Example:

client → server: Hey, give me all passwords with genid > 0
server → client: Hey, here are two. And my generation counter is currently 2.

And since those two were wrong, the client keeps asking:

client → server: Hey, give me all passwords with genid > 2
                 <server asks user for password, since it has no other passwords cached. Then assigns the new password genid 3>
server → client: here's a new one. And my generation counter is currently 3.

Client is happy now.
Comment 2 Lennart Poettering 2011-02-24 19:52:38 EST
The big advantage of the second proposal is that we never have to send passwords we already know from the client to the server. This makes it easier to support similar agents that are unprivileged which then send passwords to clients, but never the other way round.
Comment 3 Bruno Wolff III 2011-04-02 17:22:34 EDT
I am not sure if this is really the same bug I am seeing. I provide a password early in the boot process for the / filesystem. Sometimes I get asked for the /home password later in the boot process, but not always. (This is the place that things used to hang.)
Comment 4 Andy Walls 2011-06-12 22:15:26 EDT
I appear to have a bug related to password caching between systemd and plymouth.

I have a newly installed Fedora 15 x86_64.

I have a number of encrypted LVs:

/
swap
/home
/tmp
/var
/var/log
/var/log/audit

All use the same LUKS passphrase.

Graphical passphrase entry for / (and swap?) appears to go OK.

When /var needs to get unlocked, plymouth pauses the display of the "f" bubble filling in, and the graphics screen sometimes goes to a black screen.

By pressing the up-arrow key on the keyboard, I get to a text console screen where there is a prompt to enter the passphrase for /var with two * characters already apparently typed.  After backspacing over them and entering the passphase, /var gets unlocked and boot proceeds normally.

-Andy
Comment 5 Andy Walls 2011-06-13 06:08:54 EDT
I forgot to mention two things:

1. The problem is intermittent.  Sometimes I do not need to type the password in againn at the text console.

2. The volume group and non-encrypted LVs from a previous install are still on the disk in another physical partition but are not in fstab.  The text console show two messges about starting RAID, LVM,...)

-Andy
Comment 6 Frank Murphy 2011-11-05 08:53:45 EDT
Any update on this problem?

Will the comment from:
https://bugzilla.redhat.com/show_bug.cgi?id=749027#c3

work in with grub2?
And which of the /etc/grub.d/* should it go?
Comment 7 Jonas Thiem 2011-11-14 06:46:49 EST
Can we get an estimate when this will be resolved? This has to be by far the biggest regression of Fedora 15 and if it will be around for yet another year, I'll consider moving to another distribution.

Imagine you're in a rather public place and then have to enter your password 4 times, or even 5 times because you typo it once (since hard disk passwords are usually long)! That is such a nuisance and yet it doesn't seem to be an impossible task to fix this.
Comment 8 Frank Murphy 2011-11-20 07:15:37 EST
Have just noticed, on an upgrade from F14 > F15.
The option for "Global Password" is gone.
Which was there on F13,F14
Could that be part of the "plymouth" problem?
Comment 9 Andy Walls 2011-11-20 08:30:45 EST
(In reply to comment #8)
> Have just noticed, on an upgrade from F14 > F15.
> The option for "Global Password" is gone.
> Which was there on F13,F14
> Could that be part of the "plymouth" problem?

It is my understanding the architecture changed in F15.

From what I can tell:

1. The initramfs scripts are responsible for unlocking the root and swap partitions listed on the kernel command line.  The do this by doing something like:

 /bin/plymouth ask-for-password \
                --prompt "$prompt" --number-of-tries=5 \
                --command="/sbin/cryptsetup luksOpen -T1 $device $luksname"

To ask the running plymouthd to prompt for a password.  I assume plymouthd is also capable of caching passwords, so the user isn't asked more than once.


2. Once the system have done a pivot root out of the initramfs filesystem and over to the real root filesystem, systemd is run and it is responsible for unlocking the rest of the partitions.

I assume systemd ultimately invokes systemd-ask-password to prompt for the password.  It has password agents which I assume will ask plymouth for any cached password or to ask plymouth to reprompt the user.  From man systemd-ask-password:

"Existing agents are: a boot-time password agent asking the user for
 passwords using Plymouth; a boot-time password agent querying the user
 directly on the console;..."

I speculate there is a breakdown of communications between the systemd-ask-password boot-time agent for Plymouth and the running plymouthd daemon.  I also will speculate that systemd-ask-password is them falling back to it's console boot-time password agent.

I don't know why turning on plymouth debug fixes the communications for me, but it does.

HTH.

Regards,
Andy
Comment 10 Fedora End Of Life 2012-08-07 14:16:07 EDT
This message is a notice that Fedora 15 is now at end of life. Fedora
has stopped maintaining and issuing updates for Fedora 15. It is
Fedora's policy to close all bug reports from releases that are no
longer maintained. At this time, all open bugs with a Fedora 'version'
of '15' have been closed as WONTFIX.

(Please note: Our normal process is to give advanced warning of this
occurring, but we forgot to do that. A thousand apologies.)

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, feel free to reopen
this bug and simply change the 'version' to a later Fedora version.

Bug Reporter: Thank you for reporting this issue and we are sorry that
we were unable to fix it before Fedora 15 reached end of life. If you
would still like to see this bug fixed and are able to reproduce it
against a later version of Fedora, you are encouraged to click on
"Clone This Bug" (top right of this page) and open it against that
version of Fedora.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.

The process we are following is described here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping